'
'uninstall.vbs
'script for removing WebKnight from an IIS server (uses ADSI)
'
Option Explicit
Dim HostName
Dim FilterName
Dim FilterPath
Dim FilterDLLName

'-----------------------------------------------------------------
'                            Parameters
'-----------------------------------------------------------------
FilterName = "WebKnight"
FilterDLLName = "WebKnight.dll"

'-----------------------------------------------------------------
'                        Unattended Setup
'-----------------------------------------------------------------
'HostName = "LocalHost"				'uncomment this for unattended setup

UninstallIISFilterRemote FilterName, HostName

Sub UninstallIISFilterRemote(FilterName,HostName)
    
	'ask for hostname if we don't have one
	If HostName = "" Then
		HostName = InputBox("Specify the IIS host from which you want to have " & FilterName & " uninstalled","Hostname required","LocalHost")
	End If
	
	If HostName <> "" Then 'user did not cancel?
	
		'get list of installed filters
		Dim Filters
		Set Filters = GetObject("IIS://" & HostName & "/W3SVC/Filters")
		Dim LoadOrder
		LoadOrder = Filters.FilterLoadOrder
		If InStr(1,LoadOrder,FilterName)<1 Then
			MsgBox "Filter is not installed on " & HostName,,FilterName
		Else
		
			'get directory of installed filter
			Dim Filter
			Set Filter = GetObject("IIS://" & HostName & "/W3SVC/Filters/" & FilterName)
			FilterPath = Filter.FilterPath
			FilterPath = Left(FilterPath,Len(FilterPath)-Len(FilterDLLName))
			'remove trailing '\' (stupid DeleteFolder does not accept it)
			Do While Right(FilterPath,1)="\"
				FilterPath = Left(FilterPath,Len(FilterPath)-1)
			Loop
		
			'remove filter from list
			LoadOrder = Replace(LoadOrder,FilterName,"")
			LoadOrder = Replace(LoadOrder,",,",",")
			If Left(LoadOrder,1) = "," Then
				LoadOrder = Mid(LoadOrder,2)
			End If
			If Right(LoadOrder,1) = "," Then
				LoadOrder = Left(LoadOrder,Len(LoadOrder)-1)
			End If
			Filters.FilterLoadOrder = LoadOrder
			Filters.SetInfo

			'remove filter
			Filters.Delete "IIsFilter",FilterName

			'restart iis
			' TO DO

			'convert dir to unc path or leave it if it's local
			Dim path
			path = FolderToUNC(HostName,FilterPath)

			'remove installed dir if yes
			If MsgBox("Do you want to completely remove the directory " & path & " as well?",vbYesNo,FilterName)=vbYes Then
			    DeleteFolder path
			End If	

			'notify user
			MsgBox FilterName & " was succesfully uninstalled.",,FilterName
		End If
	End If
End Sub


'-----------------------------------------------------------------
'                        File System
'-----------------------------------------------------------------

Function CopyContent(HostName,Path)
	'copy files to host
	Dim ret: ret = True
	Dim src
	Dim dest: dest = FolderToUNC(HostName,Path)
	Dim fso
	Set fso = CreateObject("Scripting.FileSystemObject")
	src = fso.GetAbsolutePathName(FilterDLLName)
	src = Left(src,Len(src)-Len(filterDLLName)) & "*.*"

	On Error Resume Next
	fso.CreateFolder dest
	Err.Clear
	fso.CopyFile src, dest, False
	If Err Then
		If MsgBox("Error copying the files to " & dest & ". If you know the error (access denied, default shares don't exist,...). You can continue setup and copy all the files manually. Click Yes to continue setup, No to cancel the installation." & vbCRLF & vbCRLF & "The specified error was: " & err.number & ": " & err.Description ,vbYesNo,FilterName)=vbNo Then
			ret = False
		End If
	End If
	On Error Goto 0

	CopyContent = ret
End Function

Sub DeleteFolder(path)
	Dim fso
	Set fso = CreateObject("Scripting.FileSystemObject")
	On Error Resume Next
	fso.DeleteFolder path, True
	if Err Then
		MsgBox "There was an error deleting the files. You should do it manually, setup will continue." & vbCRLF & vbCRLF & "The specified error is: " & err.Number & ": " & err.Description,,FilterName
	End If
	On Error Goto 0
End Sub

Function FolderToUNC(HostName,Path)
	'convert dir to unc path or leave it if it's local
	If LCase(HostName)="localhost" Then
		FolderToUNC = Path
	Else
		FolderToUNC = "\\" & HostName & "\" & Replace(Path,":","$")
	End If
End Function

Sub SetNTFSPermission(Path,Username,Permission)
	'http://www.experts-exchange.com/Programming/Installation/InstallShield/Q_24315443.html
	If Right(Path,1) = "\" Then Path = Left(Path,Len(Path)-1)
	'MsgBox "cacls.exe """ & Path & """ /T /E /C /G """ & Username & """:" & Permission,,"Command"
	CreateObject("WScript.Shell").run "cacls.exe """ & Path & """ /T /E /C /G """ & Username & """:" & Permission
End Sub


