'
'install.vbs
'Script for adding WebKnight in IIS on a destination host in a destination folder (uses ADSI)
'
Option Explicit

'-----------------------------------------------------------------
'                               Host
'-----------------------------------------------------------------

Dim HostName
Dim HostNameDefault

'-----------------------------------------------------------------
'                              Filter
'-----------------------------------------------------------------

Dim FilterName
Dim FilterPath
Dim FilterPathDefault
Dim FilterDLLName
Dim FilterDesc

'-----------------------------------------------------------------
'                               ISA
'-----------------------------------------------------------------

Dim FilterGUID 						'for ISA install
Dim FilterRelativePath				'for ISA install
Dim FilterVendor					'for ISA install
Dim FilterVersion					'for ISA install

'-----------------------------------------------------------------
'                            Parameters
'-----------------------------------------------------------------

FilterPathDefault = "C:\Program Files\AQTRONIX WebKnight\"
FilterName = "WebKnight"
FilterDLLName = "WebKnight.dll"
FilterDesc = "Filter for securing IIS"

'-----------------------------------------------------------------
'                        Unattended Setup
'-----------------------------------------------------------------
'        uncomment the two lines below for unattended setup
'HostName = HostNameDefault
'FilterPath = FilterPathDefault


InstallIISFilterRemote FilterName, HostName, FilterPath

Sub InstallIISFilterRemote(FilterName,HostName,FilterPath)
	'ask for hostname if we don't have one
	If HostName = "" Then
		HostName = InputBox("Specify the IIS host where you want " & FilterName & " to be installed","Hostname required","LocalHost")
	End If
	If HostName <> "" Then 'user did not cancel?
		If FilterPath = "" Then 'ask for path to install the filter into
			FilterPath = InputBox("Specify a path on " & HostName & " where you want " & FilterName & " to be installed. This has to be an absolute path (with a local drive letter on that host, no UNC allowed here!)","Path required", FilterPathDefault)
		End If
		If FilterPath <> "" Then 'user did not cancel?
			InstallIISFilterMetabase Filtername, HostName, FilterPath
		End If
	End If
End Sub

Sub InstallIISFilterMetabase(FilterName,HostName,FilterPath)
	'Install as IIS 5 & 6 Filter

	If Left(FilterPath,1)="\" Then	'no UNC paths!
		MsgBox "No UNC paths allowed!",,FilterName
	Else
		'add trailing slash if not there
		If Right(FilterPath,1)<>"\" And Right(FilterPath,1)<>"/" Then
			FilterPath = FilterPath & "\"
		End If

		'get list of filters on the host
		Dim Filters
		Set Filters = GetObject("IIS://" & HostName & "/W3SVC/Filters")
	   	Dim LoadOrder
		LoadOrder = Filters.FilterLoadOrder

		If InStr(1,LoadOrder,FilterName)>0 Then	'filter already installed?
			MsgBox FilterName & " is already installed on " & Hostname,,FilterName
		Else

			'copy files to host
			If CopyContent(HostName, FilterPath) Then
			
    				'register filter in IIS metabase
				'set filter to be loaded first (high security) but after sspifilt & Compression
				If LoadOrder <> "" Then
					LoadOrder = "," & LoadOrder
				End If
				LoadOrder = FilterName & LoadOrder
				If InStr(1,LoadOrder,"Compression")>0 Then
					LoadOrder = Replace(LoadOrder,"Compression","")
					LoadOrder = Replace(LoadOrder,",,",",")
					LoadOrder = "Compression," & LoadOrder
				End If
				If InStr(1,LoadOrder,"sspifilt")>0 Then
					LoadOrder = Replace(LoadOrder,"sspifilt","")
					LoadOrder = Replace(LoadOrder,",,",",")
					LoadOrder = "sspifilt," & LoadOrder
				End If
				Filters.FilterLoadOrder = LoadOrder
				Filters.SetInfo

				'make filter
				Dim Filter
				Set Filter = Filters.Create("IIsFilter", FilterName)
				Filter.FilterPath = FilterPath & FilterDLLName
				Filter.FilterDescription = FilterDesc
				Filter.SetInfo

				'notify user
				MsgBox FilterName & " is succesfully installed on " & HostName & vbCRLF & vbCRLF & "You should review the settings of " & FilterName & " (by running config.exe in " & FilterPath & ") and restart IIS on " & HostName & " to load the firewall!",,FilterName
			End If
		End If
	End If
End Sub


'-----------------------------------------------------------------
'                        File System
'-----------------------------------------------------------------

Function CopyContent(HostName,Path)
	'copy files to host
	Dim ret: ret = True
	Dim src
	Dim dest: dest = FolderToUNC(HostName,Path)
	Dim fso
	Set fso = CreateObject("Scripting.FileSystemObject")
	src = fso.GetAbsolutePathName(FilterDLLName)
	src = Left(src,Len(src)-Len(filterDLLName)) & "*.*"

	On Error Resume Next
	fso.CreateFolder dest
	Err.Clear
	fso.CopyFile src, dest, False
	If Err Then
		If MsgBox("Error copying the files to " & dest & ". If you know the error (access denied, default shares don't exist,...). You can continue setup and copy all the files manually. Click Yes to continue setup, No to cancel the installation." & vbCRLF & vbCRLF & "The specified error was: " & err.number & ": " & err.Description ,vbYesNo,FilterName)=vbNo Then
			ret = False
		End If
	End If
	On Error Goto 0

	CopyContent = ret
End Function

Sub DeleteFolder(path)
	Dim fso
	Set fso = CreateObject("Scripting.FileSystemObject")
	On Error Resume Next
	fso.DeleteFolder path, True
	if Err Then
		MsgBox "There was an error deleting the files. You should do it manually, setup will continue." & vbCRLF & vbCRLF & "The specified error is: " & err.Number & ": " & err.Description,,FilterName
	End If
	On Error Goto 0
End Sub

Function FolderToUNC(HostName,Path)
	'convert dir to unc path or leave it if it's local
	If LCase(HostName)="localhost" Then
		FolderToUNC = Path
	Else
		FolderToUNC = "\\" & HostName & "\" & Replace(Path,":","$")
	End If
End Function

Sub SetNTFSPermission(Path,Username,Permission)
	'http://www.experts-exchange.com/Programming/Installation/InstallShield/Q_24315443.html
	If Right(Path,1) = "\" Then Path = Left(Path,Len(Path)-1)
	'MsgBox "cacls.exe """ & Path & """ /T /E /C /G """ & Username & """:" & Permission,,"Command"
	CreateObject("WScript.Shell").run "cacls.exe """ & Path & """ /T /E /C /G """ & Username & """:" & Permission
End Sub


